!define MUI_PRODUCT "GWhere"
!define MUI_VERSION "0.1.1"
!define MUI_BUILD_DIR "."

!include "${NSISDIR}\Contrib\Modern UI\System.nsh"

; Adds an XP manifest to the installer
XPStyle on
!define MUI_SPECIALBITMAP "${MUI_BUILD_DIR}\gwhere_install.bmp"
;!define MUI_ICON "${MUI_BUILD_DIR}\gwhere.ico"

;--------------------------------
;Configuration

  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_COMPONENTSPAGE
  !define MUI_DIRECTORYPAGE
  !define MUI_STARTMENUPAGE
  !define MUI_FINISHPAGE
  !define MUI_FINISHPAGE_RUN "$INSTDIR\gwhere.exe"
  
  !define MUI_FINISHPAGE_NOREBOOTSUPPORT

  !define MUI_ABORTWARNING
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE

  !define TEMP1 $R0



  ;Languages
  !insertmacro MUI_LANGUAGE "Czech"
  !insertmacro MUI_LANGUAGE "English"
  !insertmacro MUI_LANGUAGE "French"
  !insertmacro MUI_LANGUAGE "German"
  !insertmacro MUI_LANGUAGE "Greek"
  !insertmacro MUI_LANGUAGE "Hungarian"
  !insertmacro MUI_LANGUAGE "Polish"
  !insertmacro MUI_LANGUAGE "Portuguese"
  !insertmacro MUI_LANGUAGE "Spanish"
  !insertmacro MUI_LANGUAGE "SpanishAR"

  ; The file to write
  OutFile "gwhere-${MUI_VERSION}-win32_setup.exe"

  ;License page
  LicenseData /LANG=${LANG_CZECH} "${MUI_BUILD_DIR}\..\doc\license\license.en"
  LicenseData /LANG=${LANG_ENGLISH} "${MUI_BUILD_DIR}\..\doc\license\license.en"
  LicenseData /LANG=${LANG_FRENCH} "${MUI_BUILD_DIR}\..\doc\license\license.fr"
  LicenseData /LANG=${LANG_GERMAN} "${MUI_BUILD_DIR}\..\doc\license\license.de"
  LicenseData /LANG=${LANG_GREEK} "${MUI_BUILD_DIR}\..\doc\license\license.en"
  LicenseData /LANG=${LANG_HUNGARIAN} "${MUI_BUILD_DIR}\..\doc\license\license.en"
  LicenseData /LANG=${LANG_POLISH} "${MUI_BUILD_DIR}\..\doc\license\license.pl"
  LicenseData /LANG=${LANG_PORTUGUESE} "${MUI_BUILD_DIR}\..\doc\license\license.en"
  LicenseData /LANG=${LANG_SPANISH} "${MUI_BUILD_DIR}\..\doc\license\license.es"
  LicenseData /LANG=${LANG_SPANISHAR} "${MUI_BUILD_DIR}\..\doc\license\license.es"

  ;Component-selection page
    ;Titles
    LangString TITLE_SecCopyUI ${LANG_CZECH} "GWhere (requiered)"
    LangString TITLE_SecCopyUI ${LANG_ENGLISH} "GWhere (requiered)"
    LangString TITLE_SecCopyUI ${LANG_FRENCH} "GWhere (ncessaire)"
    LangString TITLE_SecCopyUI ${LANG_GERMAN} "GWhere (erforderlich)"
    LangString TITLE_SecCopyUI ${LANG_GREEK} "GWhere ()"
    LangString TITLE_SecCopyUI ${LANG_HUNGARIAN} "GWhere (requiered)"
    LangString TITLE_SecCopyUI ${LANG_POLISH} "GWhere (wymagany)"
    LangString TITLE_SecCopyUI ${LANG_PORTUGUESE} "GWhere (requiered)"
    LangString TITLE_SecCopyUI ${LANG_SPANISH} "Gwhere (requerido)"
    LangString TITLE_SecCopyUI ${LANG_SPANISHAR} "GWhere (requerido)"

    ;Descriptions
    LangString DESC_SecCopyUI ${LANG_CZECH} "Main engine application."
    LangString DESC_SecCopyUI ${LANG_ENGLISH} "Main engine application."
    LangString DESC_SecCopyUI ${LANG_FRENCH} "Moteur principal de l'application."
    LangString DESC_SecCopyUI ${LANG_GREEK} " ."
    LangString DESC_SecCopyUI ${LANG_GERMAN} "Hauptanwendung."
    LangString DESC_SecCopyUI ${LANG_HUNGARIAN} "Main engine application."
    LangString DESC_SecCopyUI ${LANG_POLISH} "Gwne pliki aplikacji."
    LangString DESC_SecCopyUI ${LANG_PORTUGUESE} "Main engine application."
    LangString DESC_SecCopyUI ${LANG_SPANISH} "Motor aplicacion principal."
    LangString DESC_SecCopyUI ${LANG_SPANISHAR} "Main engine application."

    ;Titles
    LangString TITLE_SecCopyGTK ${LANG_CZECH} "GTK+ 2.0 RunTime (required)"
    LangString TITLE_SecCopyGTK ${LANG_ENGLISH} "GTK+ 2.0 RunTime (required)"
    LangString TITLE_SecCopyGTK ${LANG_FRENCH} "GTK+ 2.0 RunTime (ncessaire)"
    LangString TITLE_SecCopyGTK ${LANG_GERMAN} "GTK+ 2.0 Laufzeit-Umgebung (erforderlich)"
    LangString TITLE_SecCopyGTK ${LANG_GREEK} "  GTK+ 2.0 ()"
    LangString TITLE_SecCopyGTK ${LANG_HUNGARIAN} "GTK+ 2.0 RunTime (required)"
    LangString TITLE_SecCopyGTK ${LANG_POLISH} "Biblioteki uruchomieniowe GTK+ 2.0 (wymagane)"
    LangString TITLE_SecCopyGTK ${LANG_PORTUGUESE} "GTK+ 2.0 RunTime (required)"
    LangString TITLE_SecCopyGTK ${LANG_SPANISH} "GTK+ 2.0 Runtime (requerido)"
    LangString TITLE_SecCopyGTK ${LANG_SPANISHAR} "Libreras de GTK+ 2.0 (requerido)"

    ;Descriptions
    LangString DESC_SecCopyGTK ${LANG_CZECH} "RunTime for GUI environment."
    LangString DESC_SecCopyGTK ${LANG_ENGLISH} "RunTime for GUI environment."
    LangString DESC_SecCopyGTK ${LANG_FRENCH} "Machine d'excution pour l'environnement de l'IHM."
    LangString DESC_SecCopyGTK ${LANG_GERMAN} "Laufzeit-Umgebung fr die grafische Oberflche."
    LangString DESC_SecCopyGTK ${LANG_GREEK} "    ."
    LangString DESC_SecCopyGTK ${LANG_HUNGARIAN} "RunTime for GUI environment."
    LangString DESC_SecCopyGTK ${LANG_POLISH} "Biblioteki dla rodowiska GUI."
    LangString DESC_SecCopyGTK ${LANG_PORTUGUESE} "RunTime for GUI environment."
    LangString DESC_SecCopyGTK ${LANG_SPANISH} "Runtime para entorno GUI."
    LangString DESC_SecCopyGTK ${LANG_SPANISHAR} "Libreras para la interfaz grfica de usuario."

    ;Titles
    LangString TITLE_SecCopyPLUGINS ${LANG_CZECH} "Plugins"
    LangString TITLE_SecCopyPLUGINS ${LANG_ENGLISH} "Plugins"
    LangString TITLE_SecCopyPLUGINS ${LANG_FRENCH} "Plugins"
    LangString TITLE_SecCopyPLUGINS ${LANG_GERMAN} "Erweiterunge"
    LangString TITLE_SecCopyPLUGINS ${LANG_GREEK} "Plugins"
    LangString TITLE_SecCopyPLUGINS ${LANG_HUNGARIAN} "Plugins"
    LangString TITLE_SecCopyPLUGINS ${LANG_POLISH} "Wtyczki"
    LangString TITLE_SecCopyPLUGINS ${LANG_PORTUGUESE} "Plugins"
    LangString TITLE_SecCopyPLUGINS ${LANG_SPANISH} "Plugins"
    LangString TITLE_SecCopyPLUGINS ${LANG_SPANISHAR} "Plugins"

    ;Descriptions
    LangString DESC_SecCopyPLUGINS ${LANG_CZECH} "Plugins for auto extraction of file descriptions."
    LangString DESC_SecCopyPLUGINS ${LANG_ENGLISH} "Plugins for auto extraction of file descriptions."
    LangString DESC_SecCopyPLUGINS ${LANG_FRENCH} "Modules pour l'extraction automatique des descriptions des fichiers."
    LangString DESC_SecCopyPLUGINS ${LANG_GERMAN} "Erweiterungen fr autom. Extrakt der Dateibeschreibungen."
    LangString DESC_SecCopyPLUGINS ${LANG_GREEK} "Plugins     ."
    LangString DESC_SecCopyPLUGINS ${LANG_HUNGARIAN} "Plugins for auto extraction of file descriptions."
    LangString DESC_SecCopyPLUGINS ${LANG_POLISH} "Wtyczki do automatycznego tworzenia opisw plikw."
    LangString DESC_SecCopyPLUGINS ${LANG_PORTUGUESE} "Plugins for auto extraction of file descriptions."
    LangString DESC_SecCopyPLUGINS ${LANG_SPANISH} "Plugins para autoextraccion de las descripciones de fichero."
    LangString DESC_SecCopyPLUGINS ${LANG_SPANISHAR} "Plugins para la extraccin automtica de las descripciones de archivos."

    ;Titles
    LangString TITLE_SecCopyLANG ${LANG_CZECH} "Languages Files"
    LangString TITLE_SecCopyLANG ${LANG_ENGLISH} "Languages Files"
    LangString TITLE_SecCopyLANG ${LANG_FRENCH} "Fichiers des langages"
    LangString TITLE_SecCopyLANG ${LANG_GERMAN} "Sprachdateien"
    LangString TITLE_SecCopyLANG ${LANG_GREEK} " "
    LangString TITLE_SecCopyLANG ${LANG_HUNGARIAN} "Languages Files"
    LangString TITLE_SecCopyLANG ${LANG_POLISH} "Pliki Jzykowe"
    LangString TITLE_SecCopyLANG ${LANG_PORTUGUESE} "Languages Files"
    LangString TITLE_SecCopyLANG ${LANG_SPANISH} "Ficheros de idioma"
    LangString TITLE_SecCopyLANG ${LANG_SPANISHAR} "Archivos de lenguaje"

    ;Descriptions
    LangString DESC_SecCopyLANG ${LANG_CZECH} "All languages files for the program translation."
    LangString DESC_SecCopyLANG ${LANG_ENGLISH} "All languages files for the program translation."
    LangString DESC_SecCopyLANG ${LANG_FRENCH} "Tous les fichiers des langages pour la traduction du programme."
    LangString DESC_SecCopyLANG ${LANG_GERMAN} "Alle Sprachdateien fr die Programm-bersetzung."
    LangString DESC_SecCopyLANG ${LANG_GREEK} "   ."
    LangString DESC_SecCopyLANG ${LANG_HUNGARIAN} "All languages files for the program translation."
    LangString DESC_SecCopyLANG ${LANG_POLISH} "Wszystkie pliki jzykowe."
    LangString DESC_SecCopyLANG ${LANG_PORTUGUESE} "All languages files for the program translation."
    LangString DESC_SecCopyLANG ${LANG_SPANISH} "Todos los ficheros de idioma para la traduccion del programa."
    LangString DESC_SecCopyLANG ${LANG_SPANISHAR} "Todos los archivos de lenguajes para la traduccin del programa."

  ;Folder-selection page
  InstallDir "$PROGRAMFILES\${MUI_PRODUCT}"


;--------------------------------
;Modern UI System

!insertmacro MUI_SYSTEM


;Display the Finish header
;Insert this macro after the sections if you are not using a finish page
!insertmacro MUI_SECTIONS_FINISHHEADER


;--------------------------------
;Installer Functions
; The name of the installer
;Name ${MUI_PRODUCT}


InstType Full
InstType Compact

;InstallDir $PROGRAMFILES\GWhere
InstallDirRegKey HKLM SOFTWARE\${MUI_PRODUCT} "Install_Dir"

; The stuff to install
Section $(TITLE_SecCopyUI) SecCopyUI
SectionIn 1 2 RO

SetOutPath $INSTDIR
File "${MUI_BUILD_DIR}\..\src\gwhere.exe"
File "${MUI_BUILD_DIR}\gwhere.ico"
File "${MUI_BUILD_DIR}\iconv.dll"
File "${MUI_BUILD_DIR}\libintl-1.dll"
File "${MUI_BUILD_DIR}\libz.dll"
File "${MUI_BUILD_DIR}\mingwm10.dll"
File "${MUI_BUILD_DIR}\libregex.dll"
File "${MUI_BUILD_DIR}\..\AUTHORS"
File "${MUI_BUILD_DIR}\..\BUGS"
File "${MUI_BUILD_DIR}\..\BUGS.fr"
File "${MUI_BUILD_DIR}\..\ChangeLog"
File "${MUI_BUILD_DIR}\..\ChangeLog.fr"
File "${MUI_BUILD_DIR}\..\COPYING"
File "${MUI_BUILD_DIR}\..\NEWS"
File "${MUI_BUILD_DIR}\..\README"
File "${MUI_BUILD_DIR}\..\TODO"
SetOutPath $INSTDIR
Call GetWindowsVersion
Pop $0
StrCmp $0 "95" get_win32_dll get_other_dll
get_win32_dll:
  File "${MUI_BUILD_DIR}\Ws2_32.dll"
  File "${MUI_BUILD_DIR}\Ws2help.dll"
get_other_dll:


; Write the installation path into the registry
WriteRegStr HKLM SOFTWARE\${MUI_PRODUCT} "Install_Dir" "$INSTDIR"
WriteRegStr HKCU "Software\${MUI_PRODUCT}" "Installer Language" $LANGUAGE
; Write the uninstall keys for Windows
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" "DisplayName" "${MUI_PRODUCT} ${MUI_VERSION} (remove only)"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" "UninstallString" '"$INSTDIR\uninstall.exe"'
;WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.ctg" "Application" '"$INSTDIR\gwhere.exe"'
WriteRegStr HKCR ".ctg" "" "${MUI_PRODUCT}"
WriteRegStr HKCR "${MUI_PRODUCT}\Shell\open\command" "" '"$INSTDIR\gwhere.exe" %1'
WriteRegStr HKCR "${MUI_PRODUCT}\DefaultIcon" "" "$INSTDIR\gwhere.ico"
WriteUninstaller "uninstall.exe"

  ; optional section Section "Start Menu Shortcuts"
  !insertmacro MUI_STARTMENU_WRITE_BEGIN
    CreateDirectory "$SMPROGRAMS\${MUI_STARTMENU_VARIABLE}"
    CreateShortCut "$SMPROGRAMS\${MUI_STARTMENU_VARIABLE}\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
    CreateShortCut "$SMPROGRAMS\${MUI_STARTMENU_VARIABLE}\GWhere.lnk" "$INSTDIR\gwhere.exe" "" "$INSTDIR\gwhere.exe" 0
    CreateShortCut "$SMPROGRAMS\${MUI_STARTMENU_VARIABLE}\GWhere Home Page.lnk" "http://www.gwhere.org" "" "" 0

    ;Write shortcut location to the registry (for Uninstaller)
    WriteRegStr HKCU "Software\${MUI_PRODUCT}" "Start Menu Folder" "${MUI_STARTMENU_VARIABLE}"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd


Section $(TITLE_SecCopyGTK) SecCopyGTK
SectionIn 1 2
SetOutPath $INSTDIR
File "${MUI_BUILD_DIR}\libgdk-0.dll"
File "${MUI_BUILD_DIR}\libglib-2.0-0.dll"
File "${MUI_BUILD_DIR}\libgmodule-2.0-0.dll"
File "${MUI_BUILD_DIR}\libgobject-2.0-0.dll"
File "${MUI_BUILD_DIR}\libgthread-2.0-0.dll"
File "${MUI_BUILD_DIR}\libgtk-0.dll"
SectionEnd


Section $(TITLE_SecCopyPLUGINS) SecCopyPLUGINS
SectionIn 1
SetOutPath $INSTDIR\plugins\descr
File "${MUI_BUILD_DIR}\..\src\plugins\descr\libgwplugindescriptionhtml.dll"
File "${MUI_BUILD_DIR}\..\src\plugins\descr\libgwplugindescriptionmp3.dll"
SectionEnd


Section $(TITLE_SecCopyLANG) SecCopyLANG
SectionIn 1
SetOutPath $INSTDIR\locale\ar\LC_MESSAGES
File /oname=gwhere.mo "${MUI_BUILD_DIR}\..\po\ar.gmo"
SetOutPath $INSTDIR\locale\cs\LC_MESSAGES
File /oname=gwhere.mo "${MUI_BUILD_DIR}\..\po\cs.gmo"
SetOutPath $INSTDIR\locale\de\LC_MESSAGES
File /oname=gwhere.mo "${MUI_BUILD_DIR}\..\po\de.gmo"
SetOutPath $INSTDIR\locale\el\LC_MESSAGES
File /oname=gwhere.mo "${MUI_BUILD_DIR}\..\po\el.gmo"
SetOutPath $INSTDIR\locale\es\LC_MESSAGES
File /oname=gwhere.mo "${MUI_BUILD_DIR}\..\po\es.gmo"
SetOutPath $INSTDIR\locale\fr\LC_MESSAGES
File /oname=gwhere.mo "${MUI_BUILD_DIR}\..\po\fr.gmo"
SetOutPath $INSTDIR\locale\hu\LC_MESSAGES
File /oname=gwhere.mo "${MUI_BUILD_DIR}\..\po\hu.gmo"
SetOutPath $INSTDIR\locale\pl\LC_MESSAGES
File /oname=gwhere.mo "${MUI_BUILD_DIR}\..\po\pl.gmo"
SetOutPath $INSTDIR\locale\pt\LC_MESSAGES
File /oname=gwhere.mo "${MUI_BUILD_DIR}\..\po\pt.gmo"
SectionEnd


; uninstall stuff
;UninstallText "This will uninstall GWhere. Hit next to continue."

; special uninstall section.
Section "Uninstall"
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}"
  DeleteRegKey HKLM SOFTWARE\GWhere
;  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.ctg"
  DeleteRegKey HKCR ".ctg"
  DeleteRegKey HKCR "${MUI_PRODUCT}\Shell\open\command"
  DeleteRegKey HKCR "${MUI_PRODUCT}\DefaultIcon"


  ; remove files
  Delete "$INSTDIR\gwhere.exe"
  Delete "$INSTDIR\gwhere.ico"
  Delete "$INSTDIR\iconv.dll"
  Delete "$INSTDIR\libgdk-0.dll"
  Delete "$INSTDIR\libglib-2.0-0.dll"
  Delete "$INSTDIR\libgmodule-2.0-0.dll"
  Delete "$INSTDIR\libgobject-2.0-0.dll"
  Delete "$INSTDIR\libgthread-2.0-0.dll"
  Delete "$INSTDIR\libgtk-0.dll"
  Delete "$INSTDIR\libintl-1.dll"
  Delete "$INSTDIR\libz.dll"
  Delete "$INSTDIR\mingwm10.dll"
  Delete "$INSTDIR\libregex.dll"
  Delete "$INSTDIR\AUTHORS"
  Delete "$INSTDIR\BUGS"
  Delete "$INSTDIR\BUGS.fr"
  Delete "$INSTDIR\ChangeLog"
  Delete "$INSTDIR\ChangeLog.fr"
  Delete "$INSTDIR\COPYING"
  Delete "$INSTDIR\NEWS"
  Delete "$INSTDIR\README"
  Delete "$INSTDIR\TODO"
  Delete "$INSTDIR\Ws2_32.dll"
  Delete "$INSTDIR\Ws2help.dll"
  Delete "$INSTDIR\locale\ar\LC_MESSAGES\gwhere.mo"
  RMDir "$INSTDIR\locale\ar\LC_MESSAGES"
  RMDir "$INSTDIR\locale\ar"
  Delete "$INSTDIR\locale\cs\LC_MESSAGES\gwhere.mo"
  RMDir "$INSTDIR\locale\cs\LC_MESSAGES"
  RMDir "$INSTDIR\locale\cs"
  Delete "$INSTDIR\locale\de\LC_MESSAGES\gwhere.mo"
  RMDir "$INSTDIR\locale\de\LC_MESSAGES"
  RMDir "$INSTDIR\locale\de"
  Delete "$INSTDIR\locale\el\LC_MESSAGES\gwhere.mo"
  RMDir "$INSTDIR\locale\el\LC_MESSAGES"
  RMDir "$INSTDIR\locale\el"
  Delete "$INSTDIR\locale\es\LC_MESSAGES\gwhere.mo"
  RMDir "$INSTDIR\locale\es\LC_MESSAGES"
  RMDir "$INSTDIR\locale\es"
  Delete "$INSTDIR\locale\fr\LC_MESSAGES\gwhere.mo"
  RMDir "$INSTDIR\locale\fr\LC_MESSAGES"
  RMDir "$INSTDIR\locale\fr"
  Delete "$INSTDIR\locale\hu\LC_MESSAGES\gwhere.mo"
  RMDir "$INSTDIR\locale\hu\LC_MESSAGES"
  RMDir "$INSTDIR\locale\hu"
  Delete "$INSTDIR\locale\pl\LC_MESSAGES\gwhere.mo"
  RMDir "$INSTDIR\locale\pl\LC_MESSAGES"
  RMDir "$INSTDIR\locale\pl"
  Delete "$INSTDIR\locale\pt\LC_MESSAGES\gwhere.mo"
  RMDir "$INSTDIR\locale\pt\LC_MESSAGES"
  RMDir "$INSTDIR\locale\pt"
  RMDir "$INSTDIR\locale"
  Delete "$INSTDIR\plugins\descr\libgwplugindescriptionhtml.dll"
  Delete "$INSTDIR\plugins\descr\libgwplugindescriptionmp3.dll"
  RMDir "$INSTDIR\plugins\descr"
  RMDir "$INSTDIR\plugins"


  ;MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe

  ;remove shortcuts, if any.
  ;Remove shortcut

  ReadRegStr ${TEMP1} HKCU "Software\${MUI_PRODUCT}" "Start Menu Folder"

  StrCmp ${TEMP1} "" noshortcuts
    Delete "$SMPROGRAMS\${TEMP1}\*.*"
    RMDir "$SMPROGRAMS\${TEMP1}"
  noshortcuts:

  DeleteRegValue HKCU "Software\${MUI_PRODUCT}" "Start Menu Folder"

  RMDir "$INSTDIR"


  !insertmacro MUI_UNFINISHHEADER
SectionEnd



Function .onInit

  ;Language selection

  ;Font
  Push Tahoma
  Push 10

  ;Languages
  !insertmacro MUI_LANGDLL_PUSH "Czech"
  !insertmacro MUI_LANGDLL_PUSH "English"
  !insertmacro MUI_LANGDLL_PUSH "French"
  !insertmacro MUI_LANGDLL_PUSH "German"
  !insertmacro MUI_LANGDLL_PUSH "Greek"
  !insertmacro MUI_LANGDLL_PUSH "Hungarian"
  !insertmacro MUI_LANGDLL_PUSH "Polish"
  !insertmacro MUI_LANGDLL_PUSH "Portuguese"
  !insertmacro MUI_LANGDLL_PUSH "Spanish"
  !insertmacro MUI_LANGDLL_PUSH "SpanishAR"

  Push 10F ;10 = number of languages, F = change font

  LangDLL::LangDialog "Installer Language" "Please select a language."

  Pop $LANGUAGE
  StrCmp $LANGUAGE "cancel" 0 +2
    Abort

FunctionEnd

;--------------------------------
;Descriptions

!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecCopyUI} $(DESC_SecCopyUI)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecCopyGTK} $(DESC_SecCopyGTK)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecCopyPLUGINS} $(DESC_SecCopyPLUGINS)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecCopyLANG} $(DESC_SecCopyLANG)
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END


;--------------------------------
;Uninstaller Functions

Function un.onInit

  ;Get language from registry
  ReadRegStr $LANGUAGE HKCU "Software\${MUI_PRODUCT}" "Installer Language"

FunctionEnd



 ; GetWindowsVersion
 ;
 ; Based on Yazno's function, http://yazno.tripod.com/powerpimpit/
 ; Updated by Joost Verburg
 ;
 ; Returns on top of stack
 ;
 ; Windows Version (95, 98, ME, NT x.x, 2000, XP, 2003)
 ; or
 ; '' (Unknown Windows Version)
 ;
 ; Usage:
 ;   Call GetWindowsVersion
 ;   Pop $R0
 ;   ; at this point $R0 is "NT 4.0" or whatnot
 
 Function GetWindowsVersion
 
   Push $R0
   Push $R1
 
   ReadRegStr $R0 HKLM \
   "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion

   IfErrors 0 lbl_winnt
   
   ; we are not NT
   ReadRegStr $R0 HKLM \
   "SOFTWARE\Microsoft\Windows\CurrentVersion" VersionNumber
 
   StrCpy $R1 $R0 1
   StrCmp $R1 '4' 0 lbl_error
 
   StrCpy $R1 $R0 3
 
   StrCmp $R1 '4.0' lbl_win32_95
   StrCmp $R1 '4.9' lbl_win32_ME lbl_win32_98
 
   lbl_win32_95:
     StrCpy $R0 '95'
   Goto lbl_done
 
   lbl_win32_98:
     StrCpy $R0 '98'
   Goto lbl_done
 
   lbl_win32_ME:
     StrCpy $R0 'ME'
   Goto lbl_done
 
   lbl_winnt:
 
   StrCpy $R1 $R0 1
 
   StrCmp $R1 '3' lbl_winnt_x
   StrCmp $R1 '4' lbl_winnt_x
 
   StrCpy $R1 $R0 3
 
   StrCmp $R1 '5.0' lbl_winnt_2000
   StrCmp $R1 '5.1' lbl_winnt_XP
   StrCmp $R1 '5.2' lbl_winnt_2003 lbl_error
 
   lbl_winnt_x:
     StrCpy $R0 "NT $R0" 6
   Goto lbl_done
 
   lbl_winnt_2000:
     Strcpy $R0 '2000'
   Goto lbl_done
 
   lbl_winnt_XP:
     Strcpy $R0 'XP'
   Goto lbl_done
 
   lbl_winnt_2003:
     Strcpy $R0 '2003'
   Goto lbl_done
 
   lbl_error:
     Strcpy $R0 ''
   lbl_done:
 
   Pop $R1
   Exch $R0
 
 FunctionEnd
 

; eof
